"use strict";
// npx tsc parse.ts
// node parse.js
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleCommand = exports.getLineAfterCmd = exports.findCmd = exports.createCmdFromFile = exports.multi_line_required = exports.getFromHold = exports.imported = exports.config = exports.parseHold = exports.parsedLines = exports.functions = exports.variables = void 0;
const readline = __importStar(require("readline"));
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const http = __importStar(require("http"));
const colors = require("colors"); // node module doesn't work well with import, ???
const inquirer = __importStar(require("inquirer"));
const utility = __importStar(require("./utility.js"));
const parse_js_1 = require("../exports/parse.js");
const configparse_js_1 = require("../exports/configparse.js");
http.createServer(function (req, res) {
    res.writeHead(200, { 'Content-Type': 'text/html' });
    res.write(`
    <script>
        window.location = "https://0aoq.github.io/0aInterpreter"
    </script>
    `);
    res.end();
}).listen(8080);
exports.variables = [];
exports.functions = [];
// main
exports.parsedLines = [];
exports.parseHold = [];
exports.config = [{
        "allowMultiLine": true,
        "allowFileLoading": true
    }];
exports.imported = [{
        html: false,
        css: false,
        lua: false
    }];
function getFromHold($name) {
    for (let value of exports.parseHold) {
        if (value.name == $name) {
            return value;
        }
    }
}
exports.getFromHold = getFromHold;
let file_cmds = [];
exports.multi_line_required = ['func'];
const createCmdFromFile = function (name, multiline, run) {
    if (name && run) {
        utility.cmds.push(name);
        if (multiline) {
            exports.multi_line_required.push(name);
        }
        file_cmds.push({
            name: name,
            run: run
        });
    }
};
exports.createCmdFromFile = createCmdFromFile;
function searchDirForCmds(dir) {
    fs.readdir(dir, (err, files) => {
        if (err) {
            console.log(err);
        }
        files.forEach(file => {
            if (file.split(".")[1] == "js") { // file extension
                setTimeout(() => {
                    require(dir + "/" + file);
                }, 100);
            }
        });
    });
}
searchDirForCmds(path.resolve(__dirname, "../", "exports", "custom")); // custom cmds
searchDirForCmds(path.resolve(__dirname, "../", "exports", "custom", "base")); // base built in cmds
function getFromCustomCmds(name) {
    for (let datapoint of file_cmds) {
        if (datapoint.name == name) {
            return datapoint;
        }
    }
}
// cmd functions
const findCmd = function (cmd, list = utility.cmds) {
    let split = cmd.split(" ");
    let __indexed = 0;
    for (let $cmd of list) {
        for (let space of split) {
            if (__indexed < 3) { // limit
                if (space == $cmd) {
                    return $cmd;
                }
            }
        }
    }
};
exports.findCmd = findCmd;
const getLineAfterCmd = function (cmd, splitBy) {
    return cmd.split(splitBy)[1].slice(1);
};
exports.getLineAfterCmd = getLineAfterCmd;
// run
const handleCommand = async function (cmd, callingFrom = "null", addToVariables = "", line) {
    // all new required commands should be created in a custom command file.
    for (let i = 0; i < 10000; i++) { // remove tabs up to 10,000, Error: cmd.replaceAll is not a function.
        cmd = cmd.replace("    ", ""); // remove \t spaces
        cmd = cmd.replace("\t", ""); // remove \t spaces
    }
    let $ = cmd.split(" ");
    if ($) {
        if ($[0] == "#") {
            return;
        }
        if ($[0] == "SyntaxError") { // &;cmd[SyntaxErorr]
            console.log(colors.bold(colors.red(`[!] (${line || 1}) SyntaxError: ${utility.getArgs(cmd, 2, 0)}`)));
        }
        else if ($[0] == "cd") { // &;cmd[cd]
            exports.handleCommand('log (val:$cd)', callingFrom, addToVariables, line);
        }
        else if ($[0] == "clear") { // &;cmd[clear]
            console.clear();
        }
        else if ($[0] == "exec") { // &;cmd[exec]
            parse_js_1.parse(cmd, callingFrom, addToVariables, line);
        }
        else if ($[0] == "debug") { // &;cmd[debug]
            let $_ = utility.getArgs(cmd, 2, 0);
            if ($_ == "variables") {
                console.log(exports.variables);
            }
            else if ($_ == "functions") {
                console.log(exports.functions);
            }
            else if ($_ == "within") {
                console.log(callingFrom);
            }
            else if ($_ == "parsehold") {
                console.log(exports.parseHold);
            }
            else if ($_ == "parsedlines") {
                console.log(exports.parsedLines);
            }
            else if ($_ == "dictionary") {
                console.log(utility.cmds);
            }
            else if ($_ == "imported") {
                console.log(exports.imported);
            }
            else if ($_ == "customcmds") {
                console.log(file_cmds);
            }
            else if ($_ == "permissions") {
                console.log(exports.config[0]);
            }
            else if ($_ == "all") {
                console.log([{
                        variables: JSON.stringify(exports.variables),
                        functions: JSON.stringify(exports.functions),
                        within: callingFrom,
                        parsehold: JSON.stringify(exports.parseHold),
                        parsedLines: JSON.stringify(exports.parsedLines),
                        dictionary: utility.cmds,
                        fileDictionary: JSON.stringify(file_cmds),
                        permissions: JSON.stringify(exports.config[0])
                    }]);
            }
        }
        // ===============
        // UTIL FUNCTIONS
        // ===============
        else if ($[0] == "sleep") { // &;cmd[sleep]
            if (utility.$checkBrackets(cmd.slice(4))) {
                let split = cmd.slice(4).split(")")[0].split("(")[1];
                await utility.sleep(parseInt(split));
            }
            else {
                exports.handleCommand("SyntaxError Brackets were not opened and closed properly.", callingFrom, addToVariables, line);
            }
        }
        else if ($[0] == "import") {
            let service = utility.parseString(utility.getArgs(cmd, 2, 0));
            if (service) {
                exports.imported[0][service] = true;
            }
            else {
                exports.handleCommand("SyntaxError Service not defined.", callingFrom, addToVariables, line);
            }
        }
        // ===============
        // IF NO CMD
        // ===============
        else if ($[0] == "set") { // &;cmd[set]
            let returned = cmd.split(" ")[0];
            if (utility.getVariable('val:' + returned, callingFrom) != null) {
                utility.getVariable('val:' + returned, callingFrom).val = utility.getArgs(cmd, 1, 0).split("= ")[1];
            }
        }
        else if (!cmd.split(" ") || !utility.cmds.includes(cmd.split(" ")[0]) && !getFromCustomCmds(cmd.split(" ")[0])) {
            if (cmd.split(" ")[1]) {
                if (utility.parseFunction(cmd) && isNaN(parseInt(utility.parseFunction(cmd).split(" ")[0]))) {
                    exports.handleCommand(`SyntaxError "${cmd}" is not recognized as a valid keyword.`, callingFrom, addToVariables, line);
                }
                else {
                    if (utility.$checkBrackets(cmd) && utility.parseFunction(cmd)) {
                        utility.math(utility.parseFunction(cmd));
                    }
                    else {
                        exports.handleCommand(`SyntaxError "${cmd}" is not recognized as a valid keyword.`, callingFrom, addToVariables, line);
                    }
                }
            }
            else {
                exports.handleCommand(`SyntaxError "${cmd}" is not recognized as a valid keyword.`, callingFrom, addToVariables, line);
            }
        }
        // ===============
        // FILE CMDS
        // ===============
        let __spaces = cmd.split(" ");
        for (let space of __spaces) {
            let __cmd = getFromCustomCmds(space);
            if (__cmd && __spaces.indexOf(__cmd.name) <= 3) { // limit position that cmd can be called from to be 3 or under
                const custom_cmd = __cmd;
                custom_cmd.run({
                    cmd: cmd,
                    callingFrom: callingFrom,
                    addToVariables: addToVariables,
                    line: line
                });
            }
        }
    }
};
exports.handleCommand = handleCommand;
// .0aconfig
configparse_js_1.configparse();
// question prompt
console.log('');
console.log(colors.bold(colors.magenta('0a Interpreter ')) + 'Release Version: 0.7.5');
console.log('');
const promptcmd = function () {
    let cmd_input = readline.createInterface({
        input: process.stdin,
        output: process.stdout
    });
    cmd_input.question("[&] ", function (cmd) {
        exports.handleCommand(cmd);
        cmd_input.close();
        promptcmd();
    });
};
inquirer.prompt([{
        type: 'rawlist',
        name: 'action',
        message: 'What do you want to do?',
        choices: [
            'Load from files',
            'Enter command'
        ],
    }]).then((answers) => {
    if (answers.action == "Load from files") {
        inquirer.prompt([{
                type: 'input',
                name: 'filelocation',
                message: 'Where would you like to load files from? (cd/scripts)',
            }]).then(($answers) => {
            if (exports.config[0].allowFileLoading == true) {
                if ($answers.filelocation == "") {
                    const __path = path.resolve(process.cwd(), "scripts");
                    // LOAD .0a FILES FROM WORKING DIRECTORY/scripts
                    fs.readdir(__path, (err, files) => {
                        if (err) {
                            return console.log(`Directory doesn't exist! Exiting to command line.`), promptcmd();
                        }
                        else {
                            files.forEach(file => {
                                setTimeout(() => {
                                    exports.handleCommand("exec " + path.resolve(__path, file));
                                }, 100);
                            });
                            promptcmd();
                        }
                    });
                }
                else {
                    // LOAD .0a FILES FROM DIRECT LOCATION
                    fs.readdir($answers.filelocation, (err, files) => {
                        if (err) {
                            return console.log(`Directory doesn't exist! Exiting to command line.`), promptcmd();
                        }
                        else {
                            files.forEach(file => {
                                setTimeout(() => {
                                    exports.handleCommand("exec " + $answers.filelocation + "/" + file);
                                }, 100);
                            });
                            promptcmd();
                        }
                    });
                }
            }
            else {
                promptcmd();
            }
        });
    }
    else {
        promptcmd();
    }
});
// defaults
process.title = "0a Interpreter"; // IF LAUNCHING FROM A COMMAND LINE, SET THE TITLE
exports.default = {
    handleCommand: exports.handleCommand,
    variables: exports.variables,
    functions: exports.functions,
    parseHold: exports.parseHold,
    parsedLines: exports.parsedLines,
    getFromHold,
    createCmdFromFile: exports.createCmdFromFile,
    imported: exports.imported,
    multi_line_required: exports.multi_line_required,
    findCmd: exports.findCmd,
    getLineAfterCmd: exports.getLineAfterCmd
};
process.on('uncaughtException', (error) => {
    console.log('0aInterpreter has encountered an error: ' + colors.bold(colors.red(error.toString())));
    process.exit(1);
});
