"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.configparse = void 0;
const index_js_1 = require("../core/index.js");
const utility = __importStar(require("../core/utility.js"));
const fs = require('fs');
const path = require('path');
function configparse() {
    try {
        if (fs.existsSync(path.resolve(process.cwd(), ".0aconfig"))) {
            fs.readFile(path.resolve(process.cwd(), ".0aconfig"), 'utf-8', function (err, data) {
                if (err) {
                    console.log(err);
                }
                let __init = false;
                data.split(/\r?\n/).forEach((line) => {
                    for (let i = 0; i < 10000; i++) { // remove tabs up to 10,000, Error: line.replaceAll is not a function.
                        line = line.replace("    ", ""); // remove \t spaces
                        line = line.replace("\t", ""); // remove \t spaces
                    }
                    if (line == "<config>") {
                        __init = true;
                    }
                    else if (line == "</config>") {
                        __init = false;
                    }
                    if (__init && line.split(" ")[0] != "#") {
                        let __tag_split = line.split(">");
                        let $$_ = [];
                        for (let tag of __tag_split) {
                            $$_.push(tag.split("<"));
                        }
                        __tag_split = $$_;
                        let boolean = utility.getBoolean(__tag_split[1][0]);
                        /*
                            Example: [ [ '', 'allowMultiLine' ], [ 'false', '/allowMultiLine' ], [ '' ] ]
                            
                            From:
                            <config>
                                <allowMultiLine>false</allowMultiLine>
                            </config>
                        */
                        if (boolean != null) {
                            if (__tag_split[1][1] == "/allowMultiLine") {
                                index_js_1.config[0].allowMultiLine = boolean;
                            }
                            else if (__tag_split[1][1] == "/allowFileLoading") {
                                index_js_1.config[0].allowFileLoading = boolean;
                            }
                        }
                    }
                });
            });
        }
    }
    catch (err) {
        console.error(err);
    }
}
exports.configparse = configparse;
exports.default = {
    configparse
};
